VST 3 Interfaces: IMidiMapping Class Reference
Author: Steinberg

VST 3 Interfaces VST 3.8 SDK for developing VST plug-in

Loading...
Searching...
No Matches
Public Member Functions | Static Public Attributes | List of all members
IMidiMapping Class Referenceabstract

MIDI Mapping interface: Vst::IMidiMapping. More...

`#include <ivsteditcontroller.h>`

Inheritance diagram for IMidiMapping:

## Public Member Functions
virtual tresult | getMidiControllerAssignment (int32 busIndex, int16 channel, CtrlNumber midiControllerNumber, ParamID &id)=0
| Gets an (preferred) associated ParamID for a given Input Event Bus index, channel and MIDI Controller.
Public Member Functions inherited from FUnknown
virtual tresult | queryInterface (const TUID _iid, void **obj)=0
virtual uint32 | addRef ()=0
virtual uint32 | release ()=0

## Static Public Attributes
static const FUID | iid
Static Public Attributes inherited from FUnknown
static const FUID | iid

## Detailed Description

MIDI Mapping interface: Vst::IMidiMapping.

- [plug imp]
- [extends IEditController]
- [released: 3.0.1]
- [optional]

MIDI controllers are not transmitted directly to a VST component. MIDI as hardware protocol has restrictions that can be avoided in software. Controller data in particular come along with unclear and often ignored semantics. On top of this they can interfere with regular parameter automation and the host is unaware of what happens in the plug-in when passing MIDI controllers directly.

So any functionality that is to be controlled by MIDI controllers must be exported as regular parameter. The host will transform incoming MIDI controller data using this interface and transmit them as regular parameter change. This allows the host to automate them in the same way as other parameters. CtrlNumber can be a typical MIDI controller value extended to some others values like pitchbend or aftertouch (see ControllerNumbers). If the mapping has changed, the plug-in must call IComponentHandler::restartComponent (kMidiCCAssignmentChanged) to inform the host about this change.

# Example

//--------------------------------------
// in myeditcontroller.h
class MyEditController: public EditControllerEx1, public IMidiMapping
{
//...
//---IMidiMapping---------------------------
tresult PLUGIN_API getMidiControllerAssignment (int32 busIndex, int16 channel,
CtrlNumber midiControllerNumber,
ParamID& id) override;
//---Interface---------
OBJ_METHODS (MyEditController, EditControllerEx1)
DEFINE_INTERFACES
DEF_INTERFACE (IMidiMapping)
END_DEFINE_INTERFACES (MyEditController)
REFCOUNT_METHODS (MyEditController)
};
//--------------------------------------
// in myeditcontroller.cpp
tresult PLUGIN_API MyEditController::getMidiControllerAssignment (int32 busIndex,
int16 midiChannel,
CtrlNumber midiControllerNumber,
ParamID& tag)
{
// for my first Event bus and for MIDI channel 0 and for MIDI CC Volume only
if (busIndex == 0 && midiChannel == 0 && midiControllerNumber == kCtrlVolume)
{
tag = kGainId;
return kResultTrue;
}
return kResultFalse;
}
Steinberg::Vst::EditControllerEx1
Steinberg::Vst::IMidiMapping
MIDI Mapping interface: Vst::IMidiMapping.
Definition ivsteditcontroller.h:660
Steinberg::Vst::IMidiMapping::getMidiControllerAssignment
virtual tresult getMidiControllerAssignment(int32 busIndex, int16 channel, CtrlNumber midiControllerNumber, ParamID &id)=0
Gets an (preferred) associated ParamID for a given Input Event Bus index, channel and MIDI Controller...
Steinberg::tresult
int32 tresult
Steinberg::int16
int16_t int16
Steinberg::int32
int32_t int32
Steinberg::Vst::ParamID
uint32 ParamID
parameter identifier: value in range [0, 0x7FFFFFFF].
Definition vsttypes.h:92
Steinberg::Vst::CtrlNumber
int16 CtrlNumber
MIDI controller number (see ControllerNumbers for allowed values)
Definition vsttypes.h:96
Steinberg::Vst::kCtrlVolume
@ kCtrlVolume
Channel Volume (formerly Main Volume)
Definition ivstmidicontrollers.h:34
Steinberg::kResultTrue
kResultTrue
Steinberg::kResultFalse
kResultFalse

## Member Function Documentation

## ◆ getMidiControllerAssignment()

virtual tresult getMidiControllerAssignment | ( | int32 | busIndex,
|  | int16 | channel,
|  | CtrlNumber | midiControllerNumber,
|  | ParamID & | id )
| pure virtual

Gets an (preferred) associated ParamID for a given Input Event Bus index, channel and MIDI Controller.

Parameters

  [in] | busIndex | - index of Input Event Bus
  [in] | channel | - channel of the bus
  [in] | midiControllerNumber | - see ControllerNumbers for expected values (could be bigger than 127)
  [out] | id | - return the associated ParamID to the given midiControllerNumber

Note
  [UI-thread & Connected]

## Member Data Documentation

## ◆ iid

const FUID iid
| static

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.